unit mc;

interface

uses
  Windows, StdCtrls, Spin, Controls, ExtCtrls, Classes,
  SysUtils, Inifiles,
  Forms, math,
  Dialogs,
  registry, Menus, ImgList, ComCtrls, Buttons
  ;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    SpinEdit1: TSpinEdit;
    Label2: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Edit3: TEdit;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    N2: TMenuItem;
    N4: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    Panel3: TPanel;
    Memo1: TMemo;
    bar: TStatusBar;
    Edit4: TEdit;
    Label6: TLabel;
    proflist: TComboBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Label5: TLabel;
    asend: TCheckBox;
    asendint: TSpinEdit;
    Label7: TLabel;
    N1: TMenuItem;
    SpeedButton3: TSpeedButton;
    procedure DoActionClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DoReadLinesFromFileClick(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure N7Click(Sender: TObject);
    procedure AddProfile(name:string);
    procedure DelProfile(name:string);
    procedure GetProfile(name:string);
    procedure Button1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure proflistChange(Sender: TObject);
    procedure wait;
    procedure N1Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure Memo1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  public
    flag:boolean;
    cancelled:boolean;
    total,current:integer;
  end;

var
  Form1: TForm1;
  maxnu:integer;

implementation

uses mcsetup, mcautosend, mcabout, verinfo;

{$R *.dfm}
procedure tform1.wait;
begin
    if not asend.Checked then exit;
//    timer1.Interval:=60000*asendint.Value;
    flag:=false;
    sform.progressbar2.Max:=asendint.Value*60;
    sform.progressbar2.position:=asendint.Value*60;
//    timer1.Enabled:=true;
    while not flag do application.ProcessMessages;
end;

procedure tform1.getProfile(name:string);
var n:tinifile;
begin
    n:=tinifile.create('mcreator.ini');
    edit1.Text:=n.ReadString(name,'to','agora@dna.affrc.go.jp');
    edit2.Text:=n.ReadString(name,'account','');
    edit3.Text:=n.ReadString(name,'subj','request_');
    spinedit1.Value:=n.ReadInteger(name,'splitby',5);
    edit4.text:=n.readstring(name,'prefix','');
    asendint.Value:=n.ReadInteger(name,'AutoSendInterval',25);
    asend.Checked:=n.ReadBool(name,'Autosend',false);
    n.Free;
end;

procedure tform1.delProfile(name:string);
var n:tinifile;
begin
    n:=tinifile.create('mcreator.ini');
    n.EraseSection(name);
    n.Free;
    proflist.Items.delete(proflist.Items.IndexOf(name));
end;
procedure tform1.AddProfile(name:string);
var n:tinifile;
//    i:integer;
begin
    n:=tinifile.create('mcreator.ini');

    n.writeString(name,'to',edit1.Text);
    n.writeString(name,'account',edit2.Text);
    n.writeString(name,'subj',edit3.Text);
    n.writeInteger(name,'splitby',spinedit1.Value);
    n.writestring(name,'prefix',edit4.text);
    n.WriteInteger(name,'AutoSendInterval',asendint.Value);
    n.WriteBool(name,'Autosend',asend.Checked);
    n.ReadSections(proflist.Items);

    n.Free;
   { for i:=1 to proflist.Items.Count do
        if proflist.Items.Strings[i]=name then exit;
    proflist.Items.Add(name) }
end;

procedure TForm1.DoActionClick(Sender: TObject);
var k,i,h,nu:integer;
    n:textfile;
    s,sx:string;

//CONST FILENAME='~~mc.tmp';

begin
    cancelled:=false;
    SetRoundMode(rmUp);
    flag:=false;
//    timer1.Enabled:=true;
    k:=spinedit1.Value;
    total:=round((memo1.Lines.Count-1)/k);
    if asend.Checked then begin
        sx:=';SEND';
        sform.Show;
    end else sx:=';QUEUE';
    h:=0;
    nu:=1;
    s:='c:/mc'+inttostr(nu)+'.tmp';
    assignfile(n,s);
    rewrite(n);
    for i:=0 to memo1.Lines.Count-1 do begin
        h:=h+1;
        current:=round((i-1)/k)+1;
        writeln(n,edit4.Text+memo1.lines[i]);
        if h=k then begin
            h:=0;
            closefile(n);
            if not cancelled then begin
                winexec(pchar(setup.tbpath.text+'thebat.exe /MAILC='+s+';TO='+edit1.Text+';S='+edit3.Text+inttostr(nu)+';U='+edit2.text+sx),SW_SHOW);
                if setup.CheckBox2.Checked then winexec(pchar(setup.tbpath.text+'thebat.exe /CHECKALL'),SW_SHOW);
            end;
            wait;
            nu:=nu+1;
            s:='c:/mc'+inttostr(nu)+'.tmp';
            assignfile(n,s);
            rewrite(n);
        end;
    end;
    closefile(n);
    current:=total;
    if not cancelled then begin
        winexec(pchar(setup.tbpath.text+'thebat.exe /MAILC='+s+';TO='+edit1.Text+';S='+edit3.Text+inttostr(nu)+';U='+edit2.text+sx),SW_SHOW);
        if setup.CheckBox2.Checked then winexec(pchar(setup.tbpath.text+'thebat.exe /CHECKALL'),SW_SHOW);
    end;
    if nu>maxnu then maxnu:=nu;
//    showmessage('!!');
    if setup.checkbox1.Checked and not cancelled and not asend.checked then
        winexec(pchar(setup.tbpath.text+'thebat.exe /SENDALL'),SW_SHOW);
//    timer1.Enabled:=false;
    sform.Hide;
end;

procedure TForm1.FormCreate(Sender: TObject);
var n:treginifile;
    m:tinifile;
begin
    n:=treginifile.Create;
    edit1.Text:=n.ReadString('mcreator','to','agora@dna.affrc.go.jp');
    edit2.Text:=n.ReadString('mcreator','account','');
    edit3.Text:=n.ReadString('mcreator','subj','request_');
    spinedit1.Value:=n.ReadInteger('mcreator','splitby',5);
    edit4.text:=n.readstring('mcreator','prefix','');
    asendint.Value:=n.ReadInteger('mcreator','AutoSendInterval',25);
    asend.Checked:=n.ReadBool('mcreator','Autosend',false);
    maxnu:=1;
    n.free;
    m:=tinifile.create('mcreator.ini');
    m.ReadSections(proflist.Items);
    m.free;
    form1.Caption:=form1.Caption+' '+ver_info;
end;

procedure TForm1.FormDestroy(Sender: TObject);
var i:integer;
    n:treginifile;
begin
    for i:=1 to maxnu do deletefile('c:/mc'+inttostr(i)+'.tmp');
    n:=treginifile.Create;
//    edit1.Text:=
    n.writeString('mcreator','to',edit1.Text);
    n.writeString('mcreator','account',edit2.Text);
    n.writeString('mcreator','subj',edit3.Text);
    n.writeInteger('mcreator','splitby',spinedit1.Value);
    n.writestring('mcreator','prefix',edit4.text);
    n.WriteInteger('mcreator','AutoSendInterval',asendint.Value);
    n.WriteBool('mcreator','Autosend',asend.Checked);
    n.free;

end;

procedure TForm1.DoReadLinesFromFileClick(Sender: TObject);
begin
    if opendialog1.Execute then
        memo1.Lines.LoadFromFile(opendialog1.FileName);
end;

procedure TForm1.Memo1Change(Sender: TObject);
var n:integer;
begin
    n:=memo1.Lines.Count;
    bar.Panels[0].Text:=inttostr(n)+' () ';
end;

procedure TForm1.N7Click(Sender: TObject);
begin
    setup.ShowModal;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
    addprofile(proflist.Text);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
    delprofile(proflist.Text);
end;

procedure TForm1.proflistChange(Sender: TObject);
begin
    getprofile(proflist.Text);
end;

procedure TForm1.N1Click(Sender: TObject);
begin
    aboutbox.showmodal;
end;

procedure TForm1.N4Click(Sender: TObject);
begin
    application.Terminate;
end;

procedure TForm1.Memo1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if shift=[ssCtrl] then begin
        case char(key) of
            'A':memo1.SelectAll;
            'N':memo1.SelLength:=0;
        end;

    end;


end;

end.
