unit mcsetup;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, registry, Buttons;

type
  Tsetup = class(TForm)
    CheckBox1: TCheckBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    tbpath: TEdit;
    tbloc: TOpenDialog;
    CheckBox2: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  setup: Tsetup;

implementation

{$R *.dfm}

procedure Tsetup.FormCreate(Sender: TObject);
var n:treginifile;

begin
    n:=treginifile.Create;
    setup.checkbox1.Checked:=n.ReadBool('mcreator','sendafter',false);
    setup.checkbox2.Checked:=n.ReadBool('mcreator','receive',false);
    tbpath.text:=n.ReadString('mcreator','path','');
    n.free;

end;

procedure Tsetup.BitBtn1Click(Sender: TObject);
begin
    self.Close;
end;

procedure Tsetup.BitBtn2Click(Sender: TObject);
begin
    if tbloc.Execute then begin
        tbpath.Text:=extractfilepath(tbloc.FileName);
    end;
end;

procedure Tsetup.FormDestroy(Sender: TObject);
var n:treginifile;

begin
    n:=treginifile.Create;

    n.writeBool('mcreator','sendafter',checkbox1.Checked);
    n.writeBool('mcreator','receive',checkbox1.Checked);
    n.WriteString('mcreator','path',tbpath.text);

    n.free;

end;

end.
